/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * Development of this software was sponsored by the Office of Biological  *
 * and Environmental Research of the U.S. Department of Energy's Office    *
 * of Science.                                                             *
 *                                                                         *
 * Copyright 2011 UChicago Argonne, LLC.                                   *
 *                                                                         *
 * Licensed under the Apache License, Version 2.0 (the "License"); you     *
 * may not use this file except in compliance with the License.  You may   *
 * obtain a copy of the License at                                         * 
 *                                                                         *
 *   http://www.apache.org/licenses/LICENSE-2.0                            *
 *                                                                         *
 * Unless required by applicable law or agreed to in writing, software     *
 * distributed under the License is distributed on an "AS IS" BASIS,       *
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or         *
 * implied.  See the License for the specific language governing           *
 * permissions and limitations under the License.                          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

NhlErrorTypes Ncl_Type_DATATYPE_FUNCNAME
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,nrhs)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
#ifdef BuildParNCL
    LOCALTYPE *ls,*rs;
	LOCALOUTTYPE *res;
	ng_size_t stopi = 1;
	ng_size_t linc = 0;
	ng_size_t rinc = 0;
	ng_size_t i, j;
	ng_size_t sz, nchunks;

	if(nlhs > nrhs) 
		stopi = nlhs;
	else
		stopi = nrhs;

	if(nlhs == 1){
		ls = (LOCALTYPE*)lhs;
	}
	if(nrhs == 1){
		rs = (LOCALTYPE*)rhs;
	}

	if(nlhs > 1) {
		linc = 1;
	}
	if(nrhs > 1) {
		rinc = 1;
	}

	if(nlhs > 1){
		nchunks = ParCALGetNumChunks(lhs);
	}
	else{
		nchunks = ParCALGetNumChunks(rhs);
	}

	
	for(i=0; i<nchunks; i++){
		res = (LOCALOUTTYPE *)ParCALGetVal(result, NULL, i, PARCAL_VAL_LOCAL, NULL, (PARCAL_RD | PARCAL_WR) , &sz);
		if(nlhs > 1){
			ls = (LOCALTYPE *)ParCALGetVal(lhs, NULL, i, PARCAL_VAL_LOCAL, NULL, PARCAL_RD, &sz);
		}
		if(nrhs > 1){
			rs = (LOCALTYPE *)ParCALGetVal(rhs, NULL, i, PARCAL_VAL_LOCAL, NULL, PARCAL_RD, &sz);
		}

		if((lhs_m == NULL)&&(rhs_m == NULL)) {
			for(j=0; j<sz; j++, res++, ls += linc, rs += rinc){
				*res = (LOCALOUTTYPE)(*ls THEOP *rs);
			}
		} 
		else if(rhs_m == NULL) {
			for(j=0; j<sz; j++, res++, ls += linc, rs += rinc){
				*res = (LOCALOUTTYPE)(( lhs_m->DATATYPEval == *ls) ? ( LEFTMISSING ) : (*ls THEOP *rs));
			}
		} else if(lhs_m == NULL ) {
			for(j=0; j<sz; j++, res++, ls += linc, rs += rinc){
				*res = (LOCALOUTTYPE)(( rhs_m->DATATYPEval == *rs) ? ( RIGHTMISSING ) : (*ls THEOP *rs));
			}
		} else {
			for(j=0; j<sz; j++, res++, ls += linc, rs += rinc){
				*res = (LOCALOUTTYPE)((( lhs_m->DATATYPEval == *ls)|| ( rhs_m->DATATYPEval == *rs)) ? ( LEFTMISSING ) : (*ls THEOP *rs));
			}
		}
		if(nlhs > 1){
			ParCALClearValCache(lhs, i, PARCAL_VAL_LOCAL);
		}
		if(nrhs > 1){
			ParCALClearValCache(rhs, i, PARCAL_VAL_LOCAL);
		}
		ParCALClearValCache(result, i, PARCAL_VAL_LOCAL);
	}
#endif /* BuildParNCL */

	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_DATATYPE_FUNCNAME_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypeOUTDATATYPEClass);
}
